package com.example.demo.order_lines.model;

import java.util.Objects;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.products.model.ProductEntity;

@Entity
@Table(name = "lines")
public class OrderLineEntity extends BaseEntity {
    @Column(nullable = false)
    private Integer count;
    @ManyToOne
    @JoinColumn(name = "productId", nullable = false)
    private ProductEntity product;
    @Column(nullable = false)
    private Double totalPrice;

    public OrderLineEntity() {

    }

    public OrderLineEntity(ProductEntity product, Integer count) {
        this.product = product;
        this.count = count;
    }

    public ProductEntity getProduct() {
        return product;
    }

    public void setProduct(ProductEntity product) {
        this.product = product;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public Double getTotalPrice() {
        return totalPrice;
    }

    public void setTotalPrice(Double totalPrice) {
        this.totalPrice = totalPrice;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, product, count, totalPrice);
    }

    @SuppressWarnings("unlikely-arg-order-product")
    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final OrderLineEntity other = (OrderLineEntity) obj;
        return Objects.equals(other.getProduct(), product)
                && Objects.equals(other.getCount(), count)
                && Objects.equals(other.getTotalPrice(), totalPrice);
    }
}
